#include <iostream>

using namespace std;

int main()
{
    int N;
    cin >> N;
    int O, A, B, AB;
    cin >> O >> A >> B >> AB;
    pair<string, int> grupe[N];
    for (int i = 0; i < N; ++i){
        string x;
        int y;
        cin >> x;
        cin >> y;
        grupe[i] = {x, y};
    }
    int date[N][4];
    for (int i = 0; i < N; ++i){
        for (int j = 0; j < 4; ++j)
            date[i][j] = 0;
    }
    for (int i = 0; i < N; ++i){
        if (grupe[i].first == "AB"){
            date[i][3] = min(grupe[i].second, AB);
            grupe[i].second -= date[i][3];
            AB -= date[i][3];
        }
    }
    for (int i = 0; i < N; ++i){
        if (grupe[i].first == "B"){
            date[i][2] = min(grupe[i].second, B);
            grupe[i].second -= date[i][2];
            B -= date[i][2];
        }
        if (grupe[i].first == "AB"){
            date[i][2] = min(grupe[i].second, B);
            grupe[i].second -= date[i][2];
            B -= date[i][2];
        }
    }
    for (int i = 0; i < N; ++i){
        if (grupe[i].first == "A"){
            date[i][1] = min(grupe[i].second, A);
            grupe[i].second -= date[i][1];
            A -= date[i][2];
        }
        if (grupe[i].first == "AB"){
            date[i][1] = min(grupe[i].second, A);
            grupe[i].second -= date[i][1];
            A -= date[i][1];
        }
    }
    for (int i = 0; i < N; ++i){
        if (grupe[i].first == "O"){
            date[i][0] = min(grupe[i].second, O);
            grupe[i].second -= date[i][0];
            O -= date[i][0];
        }
        if (grupe[i].first == "A"){
            date[i][0] = min(grupe[i].second, O);
            grupe[i].second -= date[i][0];
            O -= date[i][0];
        }
        if (grupe[i].first == "B"){
            date[i][0] = min(grupe[i].second, O);
            grupe[i].second -= date[i][0];
            O -= date[i][0];
        }
        if (grupe[i].first == "AB"){
            date[i][0] = min(grupe[i].second, O);
            grupe[i].second -= date[i][0];
            O -= date[i][0];
        }
    }
    bool p = false;
    for (int i = 0; i < N; ++i){
        if (grupe[i].second > 0){
            p = true;
            break;
        }
    }
    if (p) cout << "nemoguce";
    else {
        cout << "moguce" << endl;
        for (int i = 0; i < N; ++i){
            for (int j = 0; j < 4; ++j)
                cout << date[i][j] << " ";
            cout << endl;
        }
    }
    return 0;
}